﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;
using System.Threading.Tasks;
using System.Drawing;

namespace WinFormsApp1
{
    public class EntityTractor
    {
        /// <summary>
        /// Скорость
        /// </summary>
        public int Speed { get; private set; }
        /// <summary>
        /// Вес
        /// </summary>
        public float Weight { get; private set; }
        /// <summary>
        /// Цвет кузова
        /// </summary>
        public Color BodyColor { get; set; }
        /// <summary>
        /// Шаг перемещения автомобиля
        /// </summary>
        public float Step => Speed * 100 / Weight;
        /// <summary>
   
        public EntityTractor(int speed, float weight, Color bodyColor)
        {
            Random rnd = new Random();
            Speed = speed <= 0 ? rnd.Next(50, 150) : speed;
            Weight = weight <= 0 ? rnd.Next(40, 70) : weight;
            BodyColor = bodyColor;
        }

        public static EntityTractor Creator(string data)
        {
            string[] strs = data.Split(':');
            return new EntityTractor(Convert.ToInt32(strs[0]),
                Convert.ToInt32(strs[1]), Color.FromName(strs[2]));
        }
    }
}
